from mysql.driver import Driver
from tester import do_test
from record.record import analysis
from record.record import build_db
from db.conf import cnf
import numpy as np
import matplotlib.pyplot as plt
import os

build_db()

driver = Driver(scale=1)
driver.build()  # 创建9个tables
driver.load()  # 加载csv数据到9张表

do_test(driver, 600)
print('Test Finished')
driver.__del__()

result ,new_order_result = analysis()
f = open('RDSTester/result/statistics_of_five_transactions.txt', 'w')
for r in result:
    f.write(str(r['name']+' - '+'\navg time: '+ str(r['avg'])+ '\ntotal: '+str(r['total'])+'\nsuccess: '+str(r['success'])+'\n\n'))
    print(r['name'],' - ','\navg time: ', r['avg'], '\ntotal: ',r['total'],'\nsuccess: ',r['success'])
f2 = open('RDSTester/result/timecost_and_num_of_NewOrders.txt', 'w')
for n in new_order_result:
    f2.write("number: " + str(n[0]) + ", time cost: " + str(n[1]) + "\n")    
X = np.array([e[1] for e in new_order_result])
Y = np.array([e[0] for e in new_order_result])
plt.plot(X,Y)
plt.ylabel('Number of New-Orders')
plt.xlabel('Time unit: second')
plt.savefig("RDSTester/result/timecost_and_num_of_NewOrders.jpg")
plt.show()
os.remove('RDSTester/result/rds.db')



# # 原来作者写的下面那一坨就不要了
# i  = 0
# for host,  user, passwd, port, label, color in cnf:
#     driver = Driver(host=host, port=port, user=user, passwd=passwd, scale=1)
#     build_db()
#     ######
#     # If a database to be tested has not been initialized, uncomment following lines.
#     #driver.build()
#     #driver.populate()
#     #####
#     do_test(driver, 120)# #2 parameter is test duration time in seconds.
#     print('Test Finished')
#     driver.__del__()
#     result ,new_order_result = analysis()
#     f = open('result/'+label+'.txt', 'w')
#     for r in result:
#         f.write(str(r['name']+' - '+'\navg time: '+ str(r['avg'])+ '\ntotal: '+str(r['total'])+'\nsuccess: '+str(r['success'])))
#     X = np.array([e[1] for e in new_order_result])
#     Y = np.array([e[0] for e in new_order_result])
#     np.save('result/'+label+'X', X)
#     np.save('result/'+label+'Y', Y)
#     plt.plot(X, Y, color=color, label=label)
#     os.remove('rds.db')
#     i += 1
#     print('task %d finished.'%(i))

